<link href="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/css/jquery.fileupload.min.css" rel="stylesheet" type="text/css">

<div class="alert alert-danger" id="msg-formBA">
    #{if (jenis.name().equals("PENGUMUMAN_PEMENANG_AKHIR")) } &{'BA.nomor_tgl_tmpt'} #{/if}
    #{else} &{'BA.nomor_tgl'} #{/else} &{'BA.wajib_diisi'}
</div>
<div class="alert alert-danger" id="msg-invalidDokBA">
    &{'BA.untuk_doc'} ${labelDokumen} &{'BA.yg_dpt_diupload'}
</div>
<div class="alert alert-danger" id="msg-invalidDateBA">
    &{'BA.isian_tgl_doc'} ${labelDokumen} &{'BA.salah'}
</div>
#{form @lelang.BeritaAcaraCtr.cetak(id), id:'form-cetak-ba', method:'POST'}
    <input type="hidden" name="ref" value="${referer}"/>
    <input type="hidden" name="jenis" id="jenis"  value="${jenis}"/>
    <table class="table table-sm">
        <tr>
            <th width="80px" class="bg-warning">&{'BA.nomor'} ${labelDokumen} <span class="warning">*</span></th>
            <td width="100px">
                <input name="no" type="text" class="form-control" value="${berita_acara?.brt_no}"/>
            </td>
        </tr>
        <tr>
            <th width="80px" class="bg-warning">&{'BA.tanggal'} ${labelDokumen} <span class="warning">*</span></th>
            <td>
                <div class="input-group date datepicker width-normal">
                    <input name="tanggal" type="text" class="form-control datepicker" value="${berita_acara?.brt_tgl_evaluasi != null ? berita_acara?.brt_tgl_evaluasi.toDatetimepicker() : today.toDatetimepicker()}"/>
                    <div class="input-group-append">
                        <span class="input-group-text"><span class="fa fa-calendar"></span></span>
                    </div>
                </div>
            </td>
        </tr>
        <tr>
            <th width="80px" class="bg-warning">&{'BA.keterangan_tambahan_lain'} </th>
            <td width="100px">
                <textarea rows="10" cols="10" id="info" name="info" class="form-control">${berita_acara?.brt_info}</textarea>
            </td>
        </tr>
        #{if (jenis.name().equals("PENGUMUMAN_PEMENANG_AKHIR") && !lelang.isAuction()) }
        <tr>
            <th width="80px" class="bg-warning">&{'BA.tempat'} <span class="warning">*</span></th>
            <td width="100px">
                <input name="tempat" type="text" class="form-control" value="${berita_acara?.brt_tempat}"/>
            </td>
        </tr>
        #{/if}
    </table>
    <a href="javascript:void(0)" class="btn btn-success btn-sm btn-simpan btn-aksi" data-aksi="cetak" id="btn-cetak-dokumen">
        <i class="fa fa-print"></i> &{'BA.cetak'}
    </a>
    <a href="javascript:void(0)" class="btn btn-primary btn-sm btn-simpan btn-aksi" data-aksi="preview" id="btn-preview-dokumen">
        <i class="fa fa-file"></i> &{'BA.preview'}
    </a>
#{/form}

<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/vendor/jquery.ui.widget.min.js"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.iframe-transport.min.js"></script>
<script type="text/javascript">
    $(document).ready(function(){
        $("#msg-formBA").hide();
        $("#msg-invalidDokBA").hide();
        $("#msg-invalidDateBA").hide();
    });
    
    $("#datepicker").datetimepicker({
        format: 'DD-MM-YYYY HH:mm',
        showToday: true
    });
    
    $(document).on('click', '.btn-aksi', function () {
    		if (validateBA()) {
    	    		var aksi = $(this).data('aksi');
    			var jenis = $('#jenis').val();
    			if (aksi == 'cetak') {
	        		$("#form-cetak-ba").submit();
	    		} else if (aksi == 'preview') {
	    			if (jenis == 'PENGUMUMAN_PEMENANG_AKHIR') {
	    				var url = #{jsRoute @lelang.BeritaAcaraCtr.previewHasilNegosiasi(':id', ':jenis', ':no', ':tanggal', ':info', ':tempat')/};
		    			window.open(url.url({
		                 id: ${id},
		                 jenis: jenis,
		                 no: $("input[name=\"no\"]").val(),
		                 tanggal: $("input[name=\"tanggal\"]").val(),
		                 info: $('#info').val(),
		                 tempat: $("input[name=\"tempat\"]").val()
		             }),'_blank');
	    			} else {
	    				var url = #{jsRoute @lelang.BeritaAcaraCtr.preview(':id', ':jenis', ':no', ':tanggal', ':info')/};
		    			window.open(url.url({
		                 id: ${id},
		                 jenis: jenis,
		                 no: $("input[name=\"no\"]").val(),
		                 tanggal: $("input[name=\"tanggal\"]").val(),
		                 info: $('#info').val()
		             }),'_blank');
	    			}	    				    			
	    		}
		}
    }); 	
    	
	function validateBA(){
        var no = $("input[name=\"no\"]").val();
        var tanggal = $("input[name=\"tanggal\"]").val();
        var noTempat = false;
        var okDate = false;
        var okForm = false;
        
        if (${jenis.name().equals("PENGUMUMAN_PEMENANG_AKHIR") && !lelang.isAuction() }) {
        		var tempat = $("input[name=\"tempat\"]").val();
        		if (tempat == "") noTempat = true;
        		else noTempat = false;
        }
        if (tanggal != "" && !isValidDate(tanggal)) {
			$("#msg-invalidDateBA").show();
        } else {
        		$("#msg-invalidDateBA").hide();
        		okDate = true;
        }
        if (no == "" || tanggal == "" || noTempat){
            $("#msg-formBA").show();
        } else {
            $("#msg-formBA").hide();
            okForm = true;
        	}
        
        return (okDate && okForm);
    }

    function isValidDate(dateString)
    {
		// Parse the date parts to integers
        var parts = dateString.split(" ")[0].split("-");
        var day = parseInt(parts[0], 10);
        var month = parseInt(parts[1], 10);
        var year = parseInt(parts[2], 10);

        // Check the ranges of month and year
        if(year < 1000 || year > 3000 || month == 0 || month > 12)
            return false;

        var monthLength = [ 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 ];

        // Adjust for leap years
        if(year % 400 == 0 || (year % 100 != 0 && year % 4 == 0))
        monthLength[1] = 29;

        // Check the range of the day
        return day > 0 && day <= monthLength[month - 1];
    };

</script>
